#include <dos.h>
#include <stdlib.h>
#include <stdio.h>


/*
	THE FOLLOWING ROUTINES ARE FROM PART ONE OF THE TUTORIAL
*/
char *vga = MK_FP(0xA000, 0);

void SetMode13h()
{
	union REGS regs;
	regs.x.ax = 0x013;
	int86(0x10, &regs, &regs);
}

void SetTextMode()
{
	union REGS regs;
	regs.x.ax = 0x003;
	int86(0x10, &regs, &regs);
}

void PlotPixel(int x, int y, char colour)
{
	int offset;
	offset = (y*320) +x;
	*(vga + offset)=colour;
}

/*
	OUR LINE DRAWING ROUTINES
*/
void HorizontalLine(int x1, int y, int x2, int colour)
{
	int xcount;

	for(xcount = x1; xcount <= x2; xcount++)
	{
		*(vga+(y*320)+xcount)=colour;
	}
}

void VerticalLine(int x, int y1, int y2, int colour)
{
	int ycount;

	for(ycount = y1; ycount <= y2; ycount++)
	{
		*(vga+(ycount*320)+x)=colour;
	}
}

void Swap(int *a, int *b)
{
	int temp;

	temp = *a;
	*a   = *b;
	*b   = temp;
}

// General line-drawing algorithm
void Line( int x1, int y1, int x2, int y2, unsigned char colour )
{
	double xstep, ystep, x, y;
	int xlength, ylength, xcount, ycount;

	xlength = abs( x2 - x1 );
	ylength = abs( y2 - y1 );

	if(xlength == 0) // Vertical Line
		VerticalLine( x1, y1, y2, colour );

	else if(ylength == 0) // Horizontal Line
		HorizontalLine(x1, y1, x2, colour);

	else if(xlength > ylength)
	{
		if(x1 > x2)
		{
			Swap(&x1, &x2);
			Swap(&y1, &y2);
		}

		ystep = (double)(y2 - y1) / (double)(x2 - x1);
		y = y1;

		for(xcount = x1; xcount <= x2; xcount++)
		{
			PlotPixel(xcount, (int)y, colour);
			y += ystep;
		}
	}
	else
	{
		if(y1 > y2)
		{
			Swap(&x1, &x2);
			Swap(&y1, &y2);
		}

		xstep = (double)(x2 - x1) / (double)(y2 - y1);
		x = x1;

		for(ycount = y1; ycount <= y2; ycount++)
		{
			PlotPixel((int)x, ycount, colour);
			x += xstep;
			}
		}
}

void main()
{
	SetMode13h();

	// draw horizontal lines till keypressed
	while(!kbhit())
	{
		HorizontalLine(random(320),random(200),random(320),random(256));
	}
	getch(); // read in that keypress

	// draw vertical lines till keypressed
	while(!kbhit())
	{
		VerticalLine(random(320),random(200),random(200),random(256));
	}
	getch(); // read in that keypress

	// draw sloping lines till keypressed
	while(!kbhit())
	{
		Line(random(320),random(200),random(320),random(200),random(256));
	}

	SetTextMode();
}